#ifndef MATH_H
#define MATH_H

#include <cmath>

#include "Common.h"

/* Low integer powers */
static inline real pow2(real x) { return x*x; }
static inline real pow3(real x) { return x*x*x; }
static inline real pow4(real x) { return pow2(pow2(x)); }
static inline real pow5(real x) { return x*pow4(x); }
static inline real pow6(real x) { return pow3(pow2(x)); }
static inline real pow7(real x) { return x*pow6(x); }

namespace SpecialFunctions {

    /* Cylindrical Bessel functions */
    real J_0(real x);
    real J_1(real x);

    /* Spherical Bessel functions */
    real j_0(real x);
    real j_1(real x);

    /* Incomplete gamma function */
    real lower_gamma(real a, real x);
    real upper_gamma(real a, real x);
}

#endif // MATH_H
