#include "Common.h"
#include "Math.h"
#include "ODE.h"


vector<real> dydt(real t, const vector<real>& y) {
    vector<real> a(2);
    a[0] = -y[1];
    a[1] = y[0];
    return a;
}

int main(int argc, char* argv[]) {
    real ti = 0;
    real tf = 2*M_PI;
    vector<real> yi(2);
    yi[0] = 1;
    yi[1] = 0;
    array t;
    vector<array> y(2);
    real epsrel = 1e-10;

    int N = RKDP(ti, tf, yi, dydt, t, y, epsrel);
    for(int n = 0; n < N; n++)
        info("%e %e %e\n", t[n], y[0][n], y[1][n]);

    return 0;
}
